#!/usr/local/bin/perl
use strict;
use String::Random qw(random_string);
use DBI;

my $n = $ARGV[0];
my $i = 0;

my $table = join '_', 'entry', $n;
my $blogs_num = int($n / 50);

my $dbh = DBI->connect('dbi:mysql:webdb;hostname=db-host', 'root', '', {
    RaiseError => 1, PrintError => 1, AutoCommit => 0,
}) or die $DBI::errstr;
$dbh->do("DROP TABLE IF EXISTS $table");
$dbh->commit;
$dbh->do(<<"SQL");
CREATE TABLE $table (
     id INT UNSIGNED NOT NULL PRIMARY KEY AUTO_INCREMENT,
     blog_id INT UNSIGNED NOT NULL,
     title VARCHAR(255) NOT NULL,
     body TEXT,
     created_on DATETIME,
     KEY(blog_id)
) ENGINE=InnoDB;
SQL
$dbh->commit;

my $sth = $dbh->prepare(<<"SQL");
INSERT INTO $table
(blog_id, title, body, created_on)
VALUES(?, ?, ?, NOW())
SQL
while ($i < $n) {
    my $title = random_string('c' x 50);
    my $body = random_string('c' x 500);
    my $blog_id = int($i % $blogs_num) + 1;
    $sth->execute($blog_id, $title, $body);
    $i++;
    if ($i % 1000 == 0) {
        $dbh->commit;
    }
}
$dbh->commit;
$sth->finish;

